//+------------------------------------------------------------------+
//|                                     Pattern Recognition v1.0     |
//|          (complete rewrite and name change of pattern alert)     |
//|                                                                  |
//|                 Copyright  2005, Jason Robinson                 |
//|                  (jasonrobinsonuk,  jnrtrading)                  |
//|                   http://www.jnrtrading.co.uk                    |
//|                                                                  |
//|      This is still work in progress and needs LOTS of testing    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Jason Robinson (jnrtrading)."
#property link      "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Black

extern bool Show_Alert = false;
extern bool Display_Bearish_Engulfing = true;
extern bool Display_Three_Inside_Down = false;
extern bool Display_Bear_Railway = true;
extern bool Display_Bullish_Engulfing = false;
extern bool Display_Three_Inside_Up = false;
extern bool Display_Piercing_Line = false;
extern bool Display_Stars = false;
extern bool Display_Harami = false;
extern bool Display_Arrows = false;
//---- buffers
double upArrow[];
double downArrow[];
string PatternText[10000];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {

//---- indicators
   
   SetIndexStyle(0,DRAW_ARROW, EMPTY);
   SetIndexArrow(0,72);
   SetIndexBuffer(0, downArrow);
      
   SetIndexStyle(1,DRAW_ARROW, EMPTY);
   SetIndexArrow(1,71);
   SetIndexBuffer(1, upArrow);
      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   ObjectsDeleteAll(0, OBJ_TEXT);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

   double Range, AvgRange;
   int counter, setalert;
   static datetime prevtime = 0;
   int shift;
   int shift1;
   int shift2;
   int shift3;
   int shift4;
   string pattern, period;
   int setPattern = 0;
   int alert = 0;
   double O, O1, O2, O3, C, C1, C2, C3, L, L1, L2, L3, H, H1, H2, H3, body;
     
   if (prevtime == Time[0]) 
     {
      return(0);
     }
   prevtime = Time[0];  
   switch (Period())
     {
      case 1: period = "M1"; body=5*Point; break;
      case 5: period = "M5"; body=5*Point; break;
      case 15: period = "M15"; body=10*Point; break;
      case 30: period = "M30"; body=10*Point; break;      
      case 60: period = "H1"; body=20*Point; break;
      case 240: period = "H4"; body=20*Point; break;
      case 1440: period = "D1"; body=70*Point; break;
      case 10080: period = "W1"; body=120*Point; break;
      case 43200: period = "MN"; body=200*Point; break;
     }
   
   for (int j = 0; j < Bars; j++)
      { 
         PatternText[j] = "pattern-" + j;
      }
   
   for (shift = 0; shift < Bars; shift++) 
      {
      
      setalert = 0;
      counter=shift;
      Range=0;
      AvgRange=0;
      for (counter=shift ;counter<=shift+9; counter++)
         {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
         }
      Range=AvgRange/10;
      shift1 = shift + 1;
      shift2 = shift + 2;
      shift3 = shift + 3;
      shift4 = shift + 4;
      
      O = Open[shift1];
      O1 = Open[shift2];
      O2 = Open[shift3];
      O3 = Open[shift4];
      H = High[shift1];
      H1 = High[shift2];
      H2 = High[shift3];
      H3 = High[shift4];
      L = Low[shift1];
      L1 = Low[shift2];
      L2 = Low[shift3];
      L3 = Low[shift4];
      C = Close[shift1];
      C1 = Close[shift2];
      C2 = Close[shift3];
      C3 = Close[shift4];
         
   // Bearish Patterns
   
      // Check for Bearish Engulfing pattern
      if ((C1>O1)&&(O>C)&&(O-C>=body)&&(O>=C1-2*Point)&&(O1>C)&&((O-C)>=(C1-O1)))
        {
         if (Display_Bearish_Engulfing == true) 
           {
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], High[shift1] + Range*1.5);
            ObjectSetText(PatternText[shift], "Bearish Engulfing", 9, "Times New Roman", Red);
            downArrow[shift1] = High[shift1] + Range*0.5;
           }
         if (setalert == 0 && Show_Alert == true)
           {
            pattern = "Bearish Engulfing Pattern";
            setalert = 1;
           }
        }
      
      // Check for a Bear Railway Tracks pattern
      if ((C1-O1>=body)&&(O>C)&&(O>=C1-2*Point)&&(C<=(O-NormalizeDouble(((C1-O1)*0.86),Digits)))&&(C>=O1))
        {
         if (Display_Bear_Railway == true)
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], High[shift1] + Range*1.5);
            ObjectSetText(PatternText[shift], "Bear Railways", 9, "Times New Roman", Red);
            downArrow[shift1] = High[shift1] + Range*0.5;
           }
         if (setalert == 0 && Show_Alert == true) 
           {
            pattern="Dark Cloud Cover Pattern";
            setalert = 1;
           }
        }
      
      // Check for Evening Doji Star pattern
      if ((C2>O2)&&((C2-O2)/(0.001+H2-L2)>0.6)&&(C2<O1)&&(C1>O1)&&((H1-L1)>(3*(C1-O1)))&&(O>C)&&(O<O1)) 
        {
         if (Display_Stars == true)
           {
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], High[shift1] + Range*1.5);
            ObjectSetText(PatternText[shift], "Evening Doji Star", 9, "Times New Roman", Red);
            downArrow[shift1] = High[shift1] + Range*0.5;
         }
         if (setalert == 0 && Show_Alert == true)
           {
            pattern="Evening Doji Star Pattern";
            setalert = 1;
           }
        }
      
      // Check for Bearish Harami pattern
      
      if ((C1>O1)&&(O>C)&&(O<=C1)&&(O1<=C)&&((O-C)<(C1-O1)))
        {
         if (Display_Harami == true)
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], High[shift1] + Range*1.5);
            ObjectSetText(PatternText[shift], "Bearish Harami", 9, "Times New Roman", Red);
            downArrow[shift1] = High[shift1] + Range*0.5;
           }
         if (shift == 0 && Show_Alert == true) 
           {
            pattern="Bearish Harami Pattern";
            setalert = 1;
           }
        }
      
      // Check for Three Inside Down pattern
      
      if ((C2>O2)&&(O1>C1)&&(O1<=C2)&&(O2<=C1)&&((O1-C1)<(C2-O2))&&(O>C)&&(C<C1)&&(O<O1))
        {
         if (Display_Three_Inside_Down == true) 
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], High[shift1] + Range*1.5);
            ObjectSetText(PatternText[shift], "Three Inside Down", 9, "Times New Roman", Red);
            downArrow[shift1] = High[shift1] + Range*0.5;
           }
         if (shift == 0 && Show_Alert == true)
           {
            pattern="Three Inside Down Pattern";
            setalert = 1;
           }
        }
      // Check for Evening Star Pattern
      
      if ((C2>O2)&&((C2-O2)/(0.001+H2-L2)>0.6)&&(C2<O1)&&(C1>O1)&&((H1-L1)>(3*(C1-O1)))&&(O>C)&&(O<O1))
        {
         if (Display_Stars == true)
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], High[shift1] + Range*1.5);
            ObjectSetText(PatternText[shift], "Evening Star", 9, "Times New Roman", Red);
            downArrow[shift1] = High[shift1] + Range*0.5;
           }
         if (shift == 0 && Show_Alert == true)
           {
            pattern = "Evening Star Pattern";
            setalert = 1;
           }
        }
   // End of Bearish Patterns
   
   // Bullish Patterns
   
      // Check for Bullish Engulfing pattern
      
      if ((O1>C1)&&(C>O)&&(C>=O1)&&(C1>=O)&&((C-O)>=(O1-C1))) 
        {
         if (Display_Bullish_Engulfing&&(O1-C1>=body)) 
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Bullish Engulfing", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
           }
         if (shift == 0 && Show_Alert == true) 
           {
            pattern="Bullish Engulfing Pattern";
            setalert = 1;
           }
        }
      
      // Check for Bullish Harami pattern
      
      if ((O1>C1)&&(C>O)&&(C<=O1)&&(C1<=O)&&((C-O)<(O1-C1)))
        {
         if (Display_Harami == true)
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Bullish Harami", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
           }
         if (shift == 0 && Show_Alert == true)
           {
            pattern="Bullish Harami Pattern";
            setalert = 1;
           }
        }
      
      // Check for Three Inside Up pattern
      
      if ((O2>C2)&&(C1>O1)&&(C1<=O2)&&(C2<=O1)&&((C1-O1)<(O2-C2))&&(C>O)&&(C>C1)&&(O>O1)) 
        {
         if (Display_Three_Inside_Up == true)
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Three Inside Up", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
           }
         if (shift == 0 && Show_Alert == true)
           {
            pattern="Three Inside Up Pattern";
            setalert = 1;
           }
        }
      
      // Check for Piercing Line pattern
      
      if ((O1-C1>=body)&&(((O1+C1)/2)<C)&&(O<C)&&(O<C1)&&(C<O1)&&((C-O)/(0.001+(H-L))>0.6)) 
        {
         if (Display_Piercing_Line == true) 
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Piercing Line", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
           }
         if (shift == 0 && Show_Alert == true)
           {
            pattern="Piercing Line Pattern";
            setalert = 1;
           }
        }
      
      // Check for Morning Doji Star
      
      if ((O2>C2)&&((O2-C2)/(0.001+H2-L2)>0.6)&&(C2>O1)&&(O1>C1)&&((H1-L1)>(3*(C1-O1)))&&(C>O)&&(O>O1))
        {
         if (Display_Stars == true) 
           {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Morning Doji Star", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
           }
         if (shift == 0 && Show_Alert == true) 
           {
            pattern="Morning Doji Star Pattern";
            setalert = 1;
           }
        }
      
      if (setalert == 1 && shift == 0)
        {
         Alert(Symbol(), " ", period, " ", pattern);
         setalert = 0;
        }
   } // End of for loop
     
   
      
   return(0);
}
//+------------------------------------------------------------------+